package plugins.SideRatioPlugin;

import info.clearthought.layout.TableLayout;

import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.Locale;
import java.util.TreeMap;
import java.util.TreeSet;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.JTextField;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import search.ResultScrollPane;
import allrounder.DbHandler;
import allrounder.DirHandler;
import allrounder.StringLib;
import allrounder.TaggedImage;
import allrounder.plugin.YiffIndexPlugin;

public class SideRatioPlugin implements YiffIndexPlugin {
	TreeMap<String, String> mLanguageMap = null;

	public SideRatioPlugin() {
		mLanguageMap = StringLib.getLanguageMapBySystemLocale(DirHandler
				.getDirOfClass(getClass()), Locale.ENGLISH);
	}

	@Override
	public String getDescription() {
		String s = mLanguageMap.get("description");
		while (s.contains("\\n"))
			s = s.substring(0, s.indexOf("\\n")) + "\n"
					+ s.substring(s.indexOf("\\n") + 2);
		return s;
	}

	@Override
	public String getName() {
		return mLanguageMap.get("title");
	}

	@Override
	public void pluginCalled(JFrame mainFrame) {
		new SideRation(mLanguageMap, mainFrame);
	}

}

class SideRation extends JDialog {
	TreeMap<String, String> mLanguageMap = null;
	JTextField ratioOne = new JTextField("4");
	JLabel doppelpunkt = new JLabel(":");
	JTextField ratioTwo = new JTextField("3");
	JLabel labelGenauigkeit = new JLabel("Toleranz");
	JSlider slideGenauigkeit = new JSlider();
	JTextField textGenauigkeit = new JTextField("5");
	JButton suchen = new JButton();
	ResultScrollPane ergebnis = new ResultScrollPane(null);

	SideRation(TreeMap<String, String> languageMap, JFrame mainFrame) {
		mLanguageMap = languageMap;
		suchen.setText(mLanguageMap.get("search"));
		suchen.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				suche();
			}
		});
		slideGenauigkeit.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				slideGenauigkeit.setToolTipText(String.valueOf(slideGenauigkeit
						.getValue()));
			}
		});
		slideGenauigkeit.setMaximum(10);
		slideGenauigkeit.setMinimum(1);
		slideGenauigkeit.setValue(5);
		slideGenauigkeit.setMajorTickSpacing(1);
		slideGenauigkeit.setSnapToTicks(true);
		ratioOne.setPreferredSize(new Dimension(30, 20));
		doppelpunkt.setPreferredSize(new Dimension(20, 20));
		ratioTwo.setPreferredSize(new Dimension(30, 20));
		ratioOne.setHorizontalAlignment(JTextField.CENTER);
		ratioTwo.setHorizontalAlignment(JTextField.CENTER);
		doppelpunkt.setHorizontalAlignment(JTextField.CENTER);
		ergebnis.setPreferredSize(new Dimension(500, 200));
		setTitle(mLanguageMap.get("Dialog-title"));
		setSize(700, 400);
		setLocationRelativeTo(mainFrame);
		setResizable(true);
		((JPanel) this.getContentPane()).setBorder(BorderFactory
				.createEmptyBorder(10, 10, 10, 10));
		double[][] layout = {
				{ ratioOne.getPreferredScrollableViewportSize().width, 10,
						doppelpunkt.getPreferredSize().width, 10,
						ratioTwo.getPreferredSize().width, 10,
						suchen.getPreferredSize().width, 20,
						labelGenauigkeit.getPreferredSize().width, 10,
						slideGenauigkeit.getPreferredSize().width,
						TableLayout.FILL },
				{ ratioOne.getPreferredSize().height, 10, TableLayout.FILL } };
		this.setLayout(new TableLayout(layout));
		this.add(ratioOne, "0, 0");
		this.add(doppelpunkt, "2, 0, c, c");
		this.add(ratioTwo, "4, 0");
		this.add(suchen, "6, 0");
		this.add(labelGenauigkeit, "8,0");
		this.add(slideGenauigkeit, "10,0,11,0");
		this.add(ergebnis, "0, 2, 11, 2");
		setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		setVisible(true);

	}

	public void suche() {
		this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
		TreeSet<TaggedImage> allImages = DbHandler.getInstance().getAllImages();
		TreeSet<TaggedImage> findImages = new TreeSet<TaggedImage>();
		double genauigkeit = 10000000000.0;
		for (int i = 0; i < (double) slideGenauigkeit.getValue(); i++) {
			genauigkeit /= 10.0;
		}
		double x = Double.valueOf(this.ratioOne.getText())
				/ Double.valueOf(this.ratioTwo.getText());
		x = Math.round(x * genauigkeit) / genauigkeit;
		double y;
		Iterator<TaggedImage> iter = allImages.iterator();
		while (iter.hasNext()) {
			TaggedImage temp = iter.next();
			y = ((double) temp.width / (double) temp.height);
			y = Math.round(y * genauigkeit) / genauigkeit;
			if (temp.height == 0 || temp.width == 0 || x != y)
				continue;
			findImages.add(temp);
		}
		ergebnis.setImages(findImages);
		this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
	}
}